;===============================;
;Demo				;
;===============================;
;MM/DD/YYYY			;
;===============================;
;Assembled with sekas v1.00	;
;===============================;


!ROM_SIZE		= $3FFFFF

incsrc init.asm				;Includes all code necessary to initialize hardware

print "LoadCRAM @ $",pc

LoadCRAM:
	lea	($c00004),a0

	move.w	#$8f02,(a0)		;Auto-inc by 2
	move.l	#$c0000000,(a0)		;write CRAM
	
	lea	PaletteColors(pc),a1
	lea	($c00000),a0		;vram data port
	
	moveq.l	#1,d1
	
LoadCRAMLoop:
	move.w	(a1)+,(a0)
	dbfa	d1,LoadCRAMLoop

print "LoadFont @ $",pc

LoadFont:
	move.w	#$8f02,($c00004)	;Inc by 2 after each write
	move.l	#$40000000,($c00004)	;VRAM write @ $0000

	lea	font(pc),a2
	move.l	#$40000000,($c00004)	;Store font at $0000 in VRAM
	
	move.w	#$03af,d1		;Font is $760 bytes

LoadFontLoop:
	move.w	(a2)+,(a0)		;a0 = vram data port
	dbfa	d1,LoadFontLoop

print "DrawTilemap @ $",pc
	
DrawTilemap:
	move.l	#$438a0003,($c00004)	;Draw tilemap @ $C38a
	move.w	#$0016,d1		;$17 characters in the file to display

	lea	text(pc),a2
	clr.l	d3			;Use this to construct the tilemap data
	
ReadFile:
	move.b	(a2)+,d3
	subi.b	#$20,d3			;Text is ASCII
	move.w	d3,(a0)
	dbfa	d1,ReadFile

	move.w	#$8004,($c00004)	;Enable H and V counters
	move.w	#$8164,($c00004)	;Enable Vblank and Disable DMA

print "MainLoop @ $",pc

MainLoop:
	jmp	MainLoop

;print "interrupt @ $",pc

interrupt:
	rte				;Unexpected interrupt

;print "HBlank @ $",pc

HBlank:
	rte

;print "VBlank @ $",pc

VBlank:
	rte


PaletteColors:
	dw	$0000		;white
	dw	$0fff		;black

Text:
incbin	sample_text.txt

	db	$ff		;Make sure things are aligned

print "Font @ $",pc

Font:
incbin	font.dat

padbyte $ff			;Pad the ROM with empty space
pad	!ROM_SIZE

;===============================;
;Game Header			;
;===============================;
;Overwrite the default header	;
;with something specific.	;
;===============================;

org $100

	db	"SEGA MEGA DRIVE "	;System name
	db	"(C) 2011        "	;Copyright and Year/Date of Release

	db	"HELLO WORLD DEMO"	;Domestic Game Name
	db	"                "
	db	"                "

	db	"HELLO WORLD DEMO"	;Overseas Game Name
	db	"                "
	db	"                "
